/* rygel-http-seek.c generated by valac 0.44.9, the Vala compiler
 * generated from rygel-http-seek.vala, do not modify */

/*
 * Copyright (C) 2008-2009 Nokia Corporation.
 * Copyright (C) 2012 Intel Corporation.
 * Copyright (C) 2013 Cable Television Laboratories, Inc.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *         Jens Georg <jensg@openismus.com>
 *         Craig Pratt <craig@ecaspia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <glib.h>
#include <libsoup/soup.h>
#include <glib-object.h>

#define RYGEL_TYPE_HTTP_SEEK_REQUEST (rygel_http_seek_request_get_type ())
#define RYGEL_HTTP_SEEK_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_HTTP_SEEK_REQUEST, RygelHTTPSeekRequest))
#define RYGEL_HTTP_SEEK_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_HTTP_SEEK_REQUEST, RygelHTTPSeekRequestClass))
#define RYGEL_IS_HTTP_SEEK_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_HTTP_SEEK_REQUEST))
#define RYGEL_IS_HTTP_SEEK_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_HTTP_SEEK_REQUEST))
#define RYGEL_HTTP_SEEK_REQUEST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_HTTP_SEEK_REQUEST, RygelHTTPSeekRequestClass))

typedef struct _RygelHTTPSeekRequest RygelHTTPSeekRequest;
typedef struct _RygelHTTPSeekRequestClass RygelHTTPSeekRequestClass;
typedef struct _RygelHTTPSeekRequestPrivate RygelHTTPSeekRequestPrivate;
enum  {
	RYGEL_HTTP_SEEK_REQUEST_0_PROPERTY,
	RYGEL_HTTP_SEEK_REQUEST_NUM_PROPERTIES
};
static GParamSpec* rygel_http_seek_request_properties[RYGEL_HTTP_SEEK_REQUEST_NUM_PROPERTIES];

/**
 * Various errors that can be thrown when attempting to seek into a stream.
 *
 * Note: All codes must be set to Soup.Status codes
 */
typedef enum  {
	RYGEL_HTTP_SEEK_REQUEST_ERROR_INVALID_RANGE = SOUP_STATUS_BAD_REQUEST,
	RYGEL_HTTP_SEEK_REQUEST_ERROR_BAD_REQUEST = SOUP_STATUS_BAD_REQUEST,
	RYGEL_HTTP_SEEK_REQUEST_ERROR_OUT_OF_RANGE = SOUP_STATUS_REQUESTED_RANGE_NOT_SATISFIABLE
} RygelHTTPSeekRequestError;
#define RYGEL_HTTP_SEEK_REQUEST_ERROR rygel_http_seek_request_error_quark ()
struct _RygelHTTPSeekRequest {
	GObject parent_instance;
	RygelHTTPSeekRequestPrivate * priv;
};

struct _RygelHTTPSeekRequestClass {
	GObjectClass parent_class;
};

static gpointer rygel_http_seek_request_parent_class = NULL;

GQuark rygel_http_seek_request_error_quark (void);
GType rygel_http_seek_request_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelHTTPSeekRequest, g_object_unref)
#define RYGEL_HTTP_SEEK_REQUEST_UNSPECIFIED ((gint64) -1)
RygelHTTPSeekRequest* rygel_http_seek_request_construct (GType object_type);

GQuark
rygel_http_seek_request_error_quark (void)
{
	return g_quark_from_static_string ("rygel-http-seek-request-error-quark");
}

RygelHTTPSeekRequest*
rygel_http_seek_request_construct (GType object_type)
{
	RygelHTTPSeekRequest * self = NULL;
	self = (RygelHTTPSeekRequest*) g_object_new (object_type, NULL);
	return self;
}

static void
rygel_http_seek_request_class_init (RygelHTTPSeekRequestClass * klass,
                                    gpointer klass_data)
{
	rygel_http_seek_request_parent_class = g_type_class_peek_parent (klass);
}

static void
rygel_http_seek_request_instance_init (RygelHTTPSeekRequest * self,
                                       gpointer klass)
{
}

/**
 * HTTPSeekRequest is an abstract base for a variety of seek request types.
 */
GType
rygel_http_seek_request_get_type (void)
{
	static volatile gsize rygel_http_seek_request_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_http_seek_request_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelHTTPSeekRequestClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_http_seek_request_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelHTTPSeekRequest), 0, (GInstanceInitFunc) rygel_http_seek_request_instance_init, NULL };
		GType rygel_http_seek_request_type_id;
		rygel_http_seek_request_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelHTTPSeekRequest", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&rygel_http_seek_request_type_id__volatile, rygel_http_seek_request_type_id);
	}
	return rygel_http_seek_request_type_id__volatile;
}

